#  Config file for libyui-gtk
#  It defines the following variables
#  LIBYUI-GTK_INCLUDE_DIRS - include directories for libyui-gtk
#  LIBYUI-GTK_LIBRARIES    - libraries to link against
#  LIBYUI-GTK_PREFIX       - prefix where libyui-gtk is installed
#  LIBYUI-GTK_SONAME       - soname of libyui-gtk
#  LIBYUI-GTK_SONAME_MAJOR - soname of libyui-gtk
#  LIBYUI-GTK_SONAME_MINOR - soname of libyui-gtk
#  LIBYUI-GTK_SONAME_PATCH - soname of libyui-gtk

# Export the SONAME for use by plugins
SET( LIBYUI-GTK_SONAME "12.0.0" )
SET( LIBYUI-GTK_SONAME_MAJOR "12" )
SET( LIBYUI-GTK_SONAME_MINOR "0" )
SET( LIBYUI-GTK_SONAME_PATCH "0" )

# Compute paths
SET( LIBYUI-GTK_PREFIX "/usr" )
GET_FILENAME_COMPONENT( LIBYUI-GTK_CMAKE_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH )
IF( EXISTS "${LIBYUI-GTK_CMAKE_DIR}/CMakeCache.txt" )
   # In build tree
   INCLUDE( "${LIBYUI-GTK_CMAKE_DIR}/Libyui-gtkBuildTreeSettings.cmake" )
ELSE()
   SET( LIBYUI-GTK_INCLUDE_DIRS /usr/include/yui/gtk /usr/include/yui/gtk/.. )
ENDIF()

# Our library dependencies (contains definitions for IMPORTED targets)
INCLUDE( "${LIBYUI-GTK_CMAKE_DIR}/Libyui-gtkLibraryDepends.cmake" )

# These are IMPORTED targets created by Libyui-gtkLibraryDepends.cmake
SET( LIBYUI-GTK_LIBRARIES yui-gtk )

MESSAGE( STATUS "Found Libyui-gtk: ${IMPORTED_LOCATION_RELEASE} (Version: 2.49.0)" )
